--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new ()
on new (me)
  me._class = #ListWidgetItem
  me.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
  me._id = $.Qt._qx.newObject(me._class)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	obj._class = #ListWidgetItem
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- data (int) -> int|float|string
on data (me,p1)
  return $.Qt._qx.callObject(me._id,#data,p1)
end

-- flags () -> int
on flags (me)
  return $.Qt._qx.callObject(me._id,#flags)
end

-- icon () -> image
on icon (me)
  return $.Qt._qx.callObject(me._id,#icon)
end

-- setBackground (color)
on setBackground (me,p1)
  $.Qt._qx.callObject(me._id,#setBackground,p1)
end

-- setData (int,int|float|string)
on setData (me,p1,p2)
  $.Qt._qx.callObject(me._id,#setData,p1,p2)
end

-- setFlags (int)
on setFlags (me,p1)
  $.Qt._qx.callObject(me._id,#setFlags,p1)
end

-- setForeground (color)
on setForeground (me,p1)
  $.Qt._qx.callObject(me._id,#setForeground,p1)
end

-- setIcon (image|string,*bool)
on setIcon (me,p1,p2)
  $.Qt._qx.callObject(me._id,#setIcon,p1,p2)
end

-- setSortValue (int)
--on setSortValue (me,p1)
--  $.Qt._qx.callObject(me._id,#setSortValue,p1)
--end

-- setStatusTip (string)
on setStatusTip (me,p1)
  $.Qt._qx.callObject(me._id,#setStatusTip,p1)
end

-- setText (string)
on setText (me,p1)
  $.Qt._qx.callObject(me._id,#setText,p1)
end

-- setTextAlignment (int)
on setTextAlignment (me,p1)
  $.Qt._qx.callObject(me._id,#setTextAlignment,p1)
end

-- setToolTip (string)
on setToolTip (me,p1)
  $.Qt._qx.callObject(me._id,#setToolTip,p1)
end

-- setWhatsThis (string)
on setWhatsThis (me,p1)
  $.Qt._qx.callObject(me._id,#setWhatsThis,p1)
end

-- text () -> string
on text (me)
  return $.Qt._qx.callObject(me._id,#text)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

