--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
on new (me,p1)
  me._class = #MediaPlayer
  me.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newObject(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	obj._class = #MediaPlayer
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- objectName () -> string
on objectName (me)
  return $.Qt._qx.callObject(me._id,#objectName)
end

-- setObjectName (string)
on setObjectName (me,p1)
  $.Qt._qx.callObject(me._id,#setObjectName,p1)
end

-- duration () -> int
on duration (me)
  return $.Qt._qx.callObject(me._id,#duration)
end

-- error () -> int
on error (me)
  return $.Qt._qx.callObject(me._id,#error)
end

-- isAudioAvailable () -> bool
on isAudioAvailable (me)
  return $.Qt._qx.callObject(me._id,#isAudioAvailable)
end

-- isSeekable () -> bool
on isSeekable (me)
  return $.Qt._qx.callObject(me._id,#isSeekable)
end

-- isVideoAvailable () -> bool
on isVideoAvailable (me)
  return $.Qt._qx.callObject(me._id,#isVideoAvailable)
end

-- mediaStatus () -> int
on mediaStatus (me)
  return $.Qt._qx.callObject(me._id,#mediaStatus)
end

-- pause ()
on pause (me)
  $.Qt._qx.callObject(me._id,#pause)
end

-- play ()
on play (me)
  $.Qt._qx.callObject(me._id,#play)
end

-- position () -> int
on position (me)
  return $.Qt._qx.callObject(me._id,#position)
end

-- setMedia (string)
on setMedia (me,p1)
	if the paramCount>1 then $.Qt._qx.callObject(me._id,#setMedia,p1)
  else $.Qt._qx.callObject(me._id,#setMedia)
end

-- setMuted ()
on setMuted (me,p1)
  $.Qt._qx.callObject(me._id,#setMuted,p1)
end

-- setPosition (int)
on setPosition (me,p1)
  $.Qt._qx.callObject(me._id,#setPosition,p1)
end

-- setVideoOutput (WidgetID)
on setVideoOutput (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callObject(me._id,#setVideoOutput,p1)
end

-- setVolume (int)
on setVolume (me,p1)
  $.Qt._qx.callObject(me._id,#setVolume,p1)
end

-- state () -> int
on state (me)
  return $.Qt._qx.callObject(me._id,#state)
end

-- stop ()
on stop (me)
  $.Qt._qx.callObject(me._id,#stop)
end

-- volume () -> int
on volume (me)
  return $.Qt._qx.callObject(me._id,#volume)
end


----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- audioAvailableChanged -> bool
on audioAvailableChanged(me,id,p1)
  me._detach(#audioAvailableChanged,id,p1)
end

-- durationChanged -> int
on durationChanged(me,id,p1)
  me._detach(#durationChanged,id,p1)
end

-- mediaStatusChanged -> int
on mediaStatusChanged(me,id,p1)
  me._detach(#mediaStatusChanged,id,p1)
end

-- positionChanged -> int
on positionChanged(me,id,p1)
  me._detach(#positionChanged,id,p1)
end

-- videoAvailableChanged -> bool
on videoAvailableChanged(me,id,p1)
  me._detach(#videoAvailableChanged,id,p1)
end
