--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (string,*bool,int)
on new (me,p1,p2,p3)
  me._class = #RegExp
  me.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
  me._id = $.Qt._qx.newObject(me._class,VOID,p1,p2,p3)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	obj._class = #RegExp
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- captureCount () -> int
on captureCount (me)
  return $.Qt._qx.callObject(me._id,#captureCount)
end

-- capturedTexts () -> list
on capturedTexts (me)
  return $.Qt._qx.callObject(me._id,#capturedTexts)
end

-- errorString () -> string
on errorString (me)
  return $.Qt._qx.callObject(me._id,#errorString)
end

-- exactMatch (string) -> bool
on exactMatch (me,p1)
  return $.Qt._qx.callObject(me._id,#exactMatch,p1)
end

-- indexIn (string,*int,int) -> int
on indexIn (me,p1,p2,p3)
  return $.Qt._qx.callObject(me._id,#indexIn,p1,p2,p3)
end

-- isValid () -> bool
on isValid (me)
  return $.Qt._qx.callObject(me._id,#isValid)
end

-- lastIndexIn (string,*int,int) -> int
on lastIndexIn (me,p1,p2,p3)
  return $.Qt._qx.callObject(me._id,#lastIndexIn,p1,p2,p3)
end

-- matchedLength () -> int
on matchedLength (me)
  return $.Qt._qx.callObject(me._id,#matchedLength)
end

-- pos (*int) -> int
on pos (me,p1)
  return $.Qt._qx.callObject(me._id,#pos,p1)
end

-- replace (string,string) -> string
on replace (me,p1,p2)
  return $.Qt._qx.callObject(me._id,#replace,p1,p2)
end

-- setMinimal (bool)
on setMinimal (me,p1)
  $.Qt._qx.callObject(me._id,#setMinimal,p1)
end

-- split (string) -> list
on split (me,p1)
  return $.Qt._qx.callObject(me._id,#split,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

-- escape (string) -> string
on escape (scr,p1)
  return $.Qt._qx.callObject(#RegExp,#escape,p1)
end

----------------------------------------
-- SIGNALS
----------------------------------------

