--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (string,string,*int)
on new (me,p1,p2,p3)
  me._class = #Settings
  me.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
  me._id = $.Qt._qx.newObject(me._class,VOID,p1,p2,p3)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	obj._class = #Settings
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- objectName () -> string
on objectName (me)
  return $.Qt._qx.callObject(me._id,#objectName)
end

-- setObjectName (string)
on setObjectName (me,p1)
  $.Qt._qx.callObject(me._id,#setObjectName,p1)
end

-- setValue (string,string)
on setValue (me,p1,p2)
  $.Qt._qx.callObject(me._id,#setValue,p1,p2)
end

-- sync ()
on sync (me)
  $.Qt._qx.callObject(me._id,#sync)
end

-- value (string) -> string
on value (me,p1)
  return $.Qt._qx.callObject(me._id,#value,p1)
end

-- beginGroup (string)
on beginGroup (me,p1)
  $.Qt._qx.callObject(me._id,#beginGroup,p1)
end

-- endGroup ()
on endGroup (me)
  $.Qt._qx.callObject(me._id,#endGroup)
end

-- clear ()
on clear (me)
  $.Qt._qx.callObject(me._id,#clear)
end

-- remove (string)
on remove (me,p1)
  $.Qt._qx.callObject(me._id,#remove,p1)
end

-- beginReadArray (string)
on beginReadArray (me,p1)
  return $.Qt._qx.callObject(me._id,#beginReadArray,p1)
end

-- beginWriteArray (string)
on beginWriteArray (me,p1)
  $.Qt._qx.callObject(me._id,#beginWriteArray,p1)
end

-- endArray ()
on endArray (me)
  $.Qt._qx.callObject(me._id,#endArray)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

